#include "mbed.h"

#include "xbee.h"
#include "parser.h"

#define IS_COORDINATOR 1

#define PAN_ID 0xC0FFEE

Serial pc(USBTX, USBRX); // tx, rx

char recv_buff[2048] = {0};

int main() {

    ReadFile();

    xbee_init();

    char c;

    char hello_world[12] = "Hello world";

    frame_t* current_frame;
#if IS_COORDINATOR

#else
    DECLARE_ADDR64_COORD
    DECLARE_ADDR16_UNKNOWN_OR_BCAST
    transmit_request(hello_world, 11, 0, USE_ADDR64_COORD, USE_ADDR16_UNKNOWN_OR_BCAST);
#endif

    while(1) {
        /*if (pc.readable())
        {     
            c = pc.getc();
            xbee.putc(c);      
            //pc.putc(c);         
        }*/

        bool finished_packet = receive(current_frame, 2048);

        if (finished_packet)
        {
            pc.printf("DATA RECEIVED : Data count = %u", current_frame->length);
            for (int i = 0; i < current_frame->length; i++)
            {
                pc.putc(current_frame->buffer[i]);            
            }
            pc.printf("\n\r");
        }
        
    }
}
